/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_MeasurementReportDocumentTitles;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_MeasurementReportDocumentTitles;


/**
 * This class represents MeasurementReportDocumentTitles - CID7021
 */
public class MeasurementReportDocumentTitles_CID7021 
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * Instantiates a new MeasurementReportDocumentTitles_CID7021 Template 
	 */
	public MeasurementReportDocumentTitles_CID7021()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}

	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumMeasurementReportDocumentTitles Object of EnumCM_MeasurementReportDocumentTitles represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_MeasurementReportDocumentTitles enumMeasurementReportDocumentTitles)
	{
		switch(enumMeasurementReportDocumentTitles)
		{
		case IMAGING_MEASUREMENT_REPORT:
			this.strCodeValue = EnumCV_MeasurementReportDocumentTitles.IMAGING_MEASUREMENT_REPORT_126000
					.getValue();
			break;
		case ONCOLOGY_MEASUREMENT_REPORT:
			this.strCodeValue = EnumCV_MeasurementReportDocumentTitles.ONCOLOGY_MEASUREMENT_REPORT_126001
					.getValue();
			break;
		case DYNAMIC_CONTRAST_MR_MEASUREMENT_REPORT:
			this.strCodeValue = EnumCV_MeasurementReportDocumentTitles.DYNAMIC_CONTRAST_MR_MEASUREMENT_REPORT_126002
					.getValue();
			break;
		case PET_MEASUREMENT_REPORT:
			this.strCodeValue = EnumCV_MeasurementReportDocumentTitles.PET_MEASUREMENT_REPORT_126003
					.getValue();
			break;
		}
	}

	/**
	 * Sets the value for MeasurementReportDocumentTitles
	 * @param enumMeasurementReportDocumentTitles Object of EnumCM_MeasurementReportDocumentTitles.
	 */
	public void setMeasurementReportDocumentTitles(EnumCM_MeasurementReportDocumentTitles enumMeasurementReportDocumentTitles)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumMeasurementReportDocumentTitles.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.DCM.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumMeasurementReportDocumentTitles);
	}
}
